//
//  InternetLauncher.m
//  PSStill
//
//  Created by andrew on Fri Sep 22 2000.
//  Copyright (c) 2000 Stone Design. All rights reserved.
//
#import <Foundation/Foundation.h>
#import <CoreFoundation/CoreFoundation.h>
#import <Carbon/Carbon.h>
#import "InternetLauncher.h"


@implementation InternetLauncher

/*
    InternetLauncher *internetConfig;

    internetConfig = [[InternetLauncher alloc] init];
    [internetConfig launchURL:someURLString];
    [internetConfig release];

*/


#define MY_APPLICATION_SIGNATURE FOUR_CHAR_CODE('OWEB')

- init;
{
    ICInstance anInstance;

    if (![super init])
        return nil;
    if (ICStart(&anInstance, MY_APPLICATION_SIGNATURE != noErr))
        return nil;
    internetConfigInstance = (id)anInstance;
    return self;
}

- (void)dealloc;
{
    ICStop((ICInstance)internetConfigInstance);
    [super dealloc];
}

- (void)launchURL:(NSString *)urlString;
{
    const char *urlCString;
    long start, length;
    OSStatus error;

    urlCString = [urlString UTF8String];
    start = 0;
    length = strlen(urlCString);
    error = ICLaunchURL((ICInstance)internetConfigInstance, NULL, (Ptr)urlCString, length, &start, &length);
    if (error != noErr)
        [NSException raise:@"OWInternetConfigException" format:@"ICLaunchURL returned an error while launching URL %@: 0x%x (%d)", urlString, error, error];
}

@end
