//
// GIFPrefs.h
//

#import <AppKit/AppKit.h>

@interface GIFPrefs : NSObject
{
	id delayField;
	id disposalMatrix;
	id loopField;
	id loopMatrix;
	id openBrowserSwitch;
	//id transField;
	id folderField;
	id window;
        id useColorSwitch;
        id transparentColorWell;
        id globalMapSwitch;
        id minimizeOutputSwitch;
}
+ (GIFPrefs *)sharedDefaults;

- (void)loadDefaults:(id)sender;
- (void)ok:(id)sender;
- (void)orderFront:(id)sender;
- (void)restoreFactorySettings:(id)sender;
- (void)chooseDefaultFolder:(id)sender;

@end

#define DEF_DELAY	@"Delay"
#define DEF_LOOP_METHOD	@"LoopMethod"
#define DEF_LOOPS	@"NumberLoops"
//#define DEF_TRANS	@"TransparentColor"
#define USE_TRANS_COLOR	@"UseTransparentColor"
#define TRANS_COLOR	@"ClearColor"
#define DEF_USE_BROWSER	@"OpenInBrowser"
#define DEF_DISPOSAL	@"DisposalMethod"
#define DEF_DIRECTORY	@"CreationFolder"
#define DEF_MINIMIZE	@"MinimizeOutput"
#define DEF_GLOBALMAP	@"UseGlobalColorMap"

